unit FindStrt;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, ExtCtrls;

type
  TFindStrFrm = class(TForm)
    FindBtn: TButton;
    GotoBtn: TButton;
    CancelBtn: TButton;
    StrPanel: TPanel;
    StrEd: TEdit;
    StateCmb: TComboBox;
    ZipEd: TEdit;
    RadiusCmb: TComboBox;
    ZoomCmb: TComboBox;
    GridPanel: TPanel;
    StreetGrid: TStringGrid;
    SortPanel: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    CrossEd: TEdit;
    BlkEd: TEdit;
    NameBtn: TButton;
    CityBtn: TButton;
    DistBtn: TButton;
    Label8: TLabel;
    procedure FindBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure StateCmbKeyPress(Sender: TObject; var Key: Char);
    procedure DistBtnClick(Sender: TObject);
    procedure StreetGridClick(Sender: TObject);
    procedure GotoBtnClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure CityBtnClick(Sender: TObject);
    procedure NameBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FindStrFrm: TFindStrFrm;

implementation

{$R *.DFM}
 Uses Pm,PmUtil;

procedure TFindStrFrm.FindBtnClick(Sender: TObject);
Var CCnt,RCnt : Integer;
 Tstr,Tstr1,StStr: String;

begin
Try
 Screen.Cursor := CrHourGlass;
 FindList.Clear;   // See OlePmMap1 Find Event

 STreetGrid.RowCount := 2;
 GotoBtn.Enabled := False;
 NameBtn.Enabled := False;
 CityBtn.Enabled := False;
 DistBtn.Enabled := False;
StStr := StateCmb.Text;
With FstrRec,Main.OlePmMap1 do     // Center of map
Begin
 LatCtr := ((LatTop - LatBottom)/2) + LatBottom;
 LonCtr := ((LonLeft-LonRight)/2) + LonRight;
End;
If Pos('*',StStr) > 0 then StStr := '';

 If Length(Trim(ZipEd.text)) > 0 then    // If ZipCode entered
 With FstrRec,Main.OlePmMap1 do
 Begin  // Find the zip and use Lon and Lat to search for street
  FindZip(StrToInt(ZipEd.Text));
  Tstr := Main.OlePmMap1.Result;
  If Length(Tstr) > 0 then
   With FZipRec do
   Begin
    ZipCode := TabDelim(Tstr);
    City := TabDelim(Tstr);
    State := TabDelim(Tstr);
    AreaCode := TabDelim(Tstr);
    Lon := StrtoFloat(TabDelim(Tstr));
    Lat := StrToFloat(TabDelim(Tstr));
    FstrRec.LonCtr := Lon;  // Use Lon and Lat to center search
    FstrRec.LatCtr := Lat;
   End;
 End;

With FstrRec do  // Use either the ZipCode Lon,Lat or Lon,Lat of center of map
 Main.OlePmMap1.FindStr(StrEd.text,CrossEd.text,StrToIntDef(BlkEd.text,0),
   LonCtr,LatCtr,StrToFloat(RadiusCmb.text),StStr);
  // FindList is populated by the OlePmMap1 OnFind Event
  if FindList.Count > 0 Then // Found streets
  With StreetGrid do
  Begin
   { The fields in findlist are in the the following format :        }
   { Street City Block Zip Lon Lat Distance (Each separated by a tab) }
    NameBtn.Enabled := True;
    CityBtn.Enabled := True;
    DistBtn.Enabled := True;
   With FstrRec do  // Update the global record
   Begin
    Street := StrEd.Text;
    XStreet := CrossEd.Text;
    Add := StrToIntDef(BlkEd.Text,0);
    StStr := StateCmb.Text;

    ZipCode := ZipEd.text;
    if ZoomCmb.text = '' then Zoom := 1
     else
    Zoom := StrToFloat(ZoomCmb.text);
    if RadiusCmb.text = '' Then mRadius :=4
     else
    mRadius := StrToFloat(RadiusCmb.text);
    StStr := StateCmb.text;
   End;

   RowCount := FindList.Count;
   SortPanel.Caption := IntToStr(FindList.count)+ ' Items found.';

   For Rcnt := 0 to FindList.Count-1 do  // Place the information in the grid
    Begin
     Tstr := FindList.Strings[Rcnt];

       Cells[1,Rcnt+1] := TabDelim(Tstr);  // Street
       Cells[2,Rcnt+1] := TabDelim(Tstr);  // City
       Cells[0,Rcnt+1] := TabDelim(Tstr);  // Blk or addr
       for CCnt := 3 to 8 do
        Cells[CCnt,Rcnt+1] := TabDelim(Tstr);
     
    End;

  End;
 Finally
  Screen.Cursor := CrDefault;
 End;
end;

procedure TFindStrFrm.FormCreate(Sender: TObject);
begin

 With StreetGrid do
 Begin
  ColWidths[0] := 70;//140;
  ColWidths[1] := 140;//100;
  ColWidths[2] := 100;//60;
  ColWidths[3] := 20;
  ColWidths[4] := 40;
  ColWidths[5] := 70;
  ColWidths[5] := 70;
  ColWidths[7] := 60;
  Cells[0,0] := 'Block';//'Street';
  Cells[1,0] := 'Street';//'City';
  Cells[2,0] := 'City';//'Block';
  Cells[3,0] := 'St';
  Cells[4,0] := 'Zip';
  Cells[5,0] := 'Longitude';
  Cells[6,0] := 'Latitude';
  Cells[7,0] := 'Distance'
 End;
 
  with FStrRec do
  Begin
   StrEd.Text := Street;
   CrossEd.Text := XStreet;
   if Add = 0 then BlkEd.text := ''
    else
   BlkEd.Text := IntToStr(Add);
   StateCmb.Text := StStr;
   if mRadius <= 0.05 then
    RadiusCmb.Text := '4'
   else
    RadiusCmb.Text := FloatToStr(mRadius);
   ZipEd.text := ZipCode;
   If Zoom <> 0.0 then
    ZoomCmb.text := FloatToStr(Zoom)
   else
    ZoomCmb.text := '1'; ;
  End;
end;

procedure TFindStrFrm.StateCmbKeyPress(Sender: TObject; var Key: Char);
begin
 StateCmb.ItemIndex := StateCmb.Items.indexof(StateCmb.text);

end;

procedure TFindStrFrm.DistBtnClick(Sender: TObject);
Var Rcnt,Ccnt : Integer;
    SortList : TstringList;
    DistStr,TempStr,TempStr1 : String;
begin

   Try
   { The fields in findlist are in the the following format :                 }
   { Street City Block Zip Lon Lat Distance (Each separated by a tab)         }
   { We will order display in ascending order of distance using a stringlist }

   SortList := TstringList.Create;
   For Rcnt := 0 to FindList.Count-1 do  // Sort the strings returned by FindStr
   Begin  // Must sort on last item in list
    TempStr := FindList.Strings[Rcnt];
    TempStr1 := '';

    For Ccnt := 1 to 7 do TempStr1 := TempStr1 + TabDelim(TempStr)+#9;
    DistStr := Trim(TabDelim(TempStr));  // Distance is last item
    If length(DistStr) = 0 then DistStr := '00.00';

    Case Pos('.',DistStr) of
    0 : DistStr := DistStr + '.00';
    1 : DistStr := '00'+ DistStr;
    2 : DistStr := '0' + DistStr;
    End;

    SortList.Add(DistStr + #9 + TempStr1); // Put the Last Item First
   End;
    SortList.Sorted := True;
    With StreetGrid do
  Begin
    { The fields in findlist are in the the following format :        }
   { Street City Block Zip Lon Lat Distance (Each separated by a tab) }

   RowCount := SortList.Count;
   SortPanel.Caption := IntToStr(SortList.count);
   For Rcnt := 0 to SortList.Count-1 do
    Begin
     TempStr := SortList.Strings[Rcnt];
     Cells[7,Rcnt+1] := TabDelim(TempStr);  // Distance was first
     Cells[1,Rcnt+1] := TabDelim(TempStr);  // Street
     Cells[2,Rcnt+1] := TabDelim(TempStr);  // City
     Cells[0,Rcnt+1] := TabDelim(TempStr);  // st
     Cells[3,Rcnt+1] := TabDelim(TempStr);  // Blk or addr
       for CCnt := 4 to 6 do
        Cells[CCnt,Rcnt+1] := TabDelim(TempStr);

   End;
  End;
  Except

  End;  // except
end;

procedure TFindStrFrm.StreetGridClick(Sender: TObject);
begin
  If (FindList.Count > 0) And (StreetGrid.Row > -1) Then
  with StreetGrid do
  Begin
   SortPanel.Caption := Cells[5,Row] +' , '+ Cells[6,Row];
   GotoBtn.Enabled := True;
  End;
end;

procedure TFindStrFrm.GotoBtnClick(Sender: TObject);
begin
with StreetGrid,FstrRec do
Begin
 zoom := 1.0;
 Street := Cells[1,Row];
 City := Cells[2,Row];
 StStr := Cells[3,2];//StateCmb.text;
 Add := StrToIntDef(Cells[0,Row],0);
 ZipCode := Cells[4,Row];
 LonCtr := StrToFloat(Cells[5,Row]);
 LatCtr := StrToFloat(Cells[6,Row]);
 XStreet := CrossEd.text;

 if Length(ZoomCmb.Text) <> 0 then
  Zoom := StrToFloat(ZoomCmb.text);

 With Main.OlePmMap1 do
 Begin
  AutoPaint := False;
  Miles := StrToFloat(ZoomCmb.text);
  GotoPoint(LonCtr,LatCtr);
  AutoPaint := True;
  Redraw
 End;

End;
end;

procedure TFindStrFrm.CancelBtnClick(Sender: TObject);
begin
 Close;
end;

procedure TFindStrFrm.CityBtnClick(Sender: TObject);
Var Rcnt,Ccnt : Integer;
    SortList : TstringList;
    CityStr,TempStr,TempStr1 : String;
begin

   Try
   { The fields in findlist are in the the following format :                 }
   { Street City Block Zip Lon Lat Distance (Each separated by a tab)         }
   { We will order display in ascending order of City using a stringlist      }

   SortList := TstringList.Create;
   For Rcnt := 0 to FindList.Count-1 do  // Sort the strings returned by FindStr
   Begin
    TempStr := FindList.Strings[Rcnt];
    TempStr1 := '';

    TempStr1 := TabDelim(TempStr)+#9;// Street
    CityStr := TabDelim(TempStr) +#9;// City
    TempStr1 := CityStr + TempStr1;  // Reverse order in the string, City 1st
    For Ccnt := 2 to 8 do TempStr1 := TempStr1 + TabDelim(TempStr)+#9;

    SortList.Add(TempStr1);
   End;
    SortList.Sorted := True;
    With StreetGrid do
  Begin
    { The fields in findlist are in the the following format :        }
   { Street City Block Zip Lon Lat Distance (Each separated by a tab) }

   RowCount := SortList.Count;
   SortPanel.Caption := IntToStr(SortList.count);
   For Rcnt := 0 to SortList.Count-1 do
    Begin
     TempStr := SortList.Strings[Rcnt];

       Cells[2,Rcnt+1] := TabDelim(TempStr);  // City
       Cells[1,Rcnt+1] := TabDelim(TempStr);  // Street
       Cells[0,Rcnt+1] := TabDelim(TempStr);  // Blk or addr
       for CCnt := 3 to 8 do
        Cells[CCnt,Rcnt+1] := TabDelim(TempStr);

    End;
  End;
  Except

  End;  // except

end;

procedure TFindStrFrm.NameBtnClick(Sender: TObject);
 Var Rcnt,CCnt : Integer;
     Tstr : String;
begin
 if FindList.Count > 0 Then // Found streets
  With StreetGrid do
  Begin
   
   RowCount := FindList.Count;

   For Rcnt := 0 to FindList.Count-1 do  // Place the information in the grid
    Begin
     Tstr := FindList.Strings[Rcnt];
      
       Cells[1,Rcnt+1] := TabDelim(Tstr);  // Street
       Cells[2,Rcnt+1] := TabDelim(Tstr);  // City
       Cells[0,Rcnt+1] := TabDelim(Tstr);  // Blk or addr
       for CCnt := 3 to 8 do
        Cells[CCnt,Rcnt+1] := TabDelim(Tstr);

     
    End;

  End;
end;

end.
