unit Mileage;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  Grids, DBGrids, DB, DBTables, StdCtrls, Buttons, ExtCtrls;

type
  TMiles = class(TForm)
    MileageSource: TDataSource;
    MileageTable: TTable;
    MilesDBGrid1: TDBGrid;
    MilesRadioGroup: TRadioGroup;
    PrintButton: TSpeedButton;
    CloseBtn: TBitBtn;
    HelpBtn: TBitBtn;
    PrintMileageReportSpeedButton: TSpeedButton;
    MileageTableDATE: TDateField;
    MileageTableMONTH: TIntegerField;
    MileageTableMILES: TIntegerField;
    MileageTableNOTE: TStringField;
    DateEdit: TEdit;
    Redo: TSpeedButton;
    Start: TSpeedButton;
    LoadLastYear: TSpeedButton;
    procedure CloseBtnClick(Sender: TObject);
    procedure MilesRadioGroupClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure PrintButtonClick(Sender: TObject);
    procedure PrintMileageReportSpeedButtonClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure StartClick(Sender: TObject);
    procedure RedoClick(Sender: TObject);
    procedure LoadLastYearClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Miles: TMiles;

implementation

uses MileRep, DataMod;
var GotLoadedLastYear:Boolean;
{$R *.DFM}
 { ONCREATE this form...
 get the date and use the month to select which button is checked
 AND which range of records are displayed }
 procedure TMiles.FormShow(Sender: TObject);
begin
  Left := 228;
  Top := 141;
  DateEdit.Text:=DateToStr(Date);
  GotLoadedLastYear:=False;
  MilesRadioGroup.ItemIndex:= 12; {All 12 months of data}
end;

procedure TMiles.CloseBtnClick(Sender: TObject);
begin
If GotLoadedLastYear then begin
  with MileageTable do  begin
  Active := False;
  DatabaseName := 'MOWV';
  TableName := 'Mileage.DB';
  TableType := ttParadox;
  Active := True;
  end;
    MileageTable.Filtered:=False;
    MileageTable.Filter:= '';
  GotLoadedLastYear:=False;
  MilesRadioGroup.ItemIndex:= 12; {All 12 months of data}
end;
Close;
end;

procedure TMiles.LoadLastYearClick(Sender: TObject);
var  YearS,ExtractedDir:String;
     OKsofar:Boolean;
begin{Load last years database}
YearS := FormatDateTime('YYYY', (Date-365));
OKsofar:= True;
ExtractedDir:=ExtractFilePath(MOWZDB.DataDirectory);
{Load last years Client and POC .db}
if (NOT(FileExists(ExtractedDir+'Mileage_'+YearS + '.DB'))) then
    OKsofar:= False;
If  OKsofar then begin
  {load last years mileage}
  with MileageTable do  begin
  Active := False;
  DatabaseName := 'MOWV';
  TableName := 'Mileage_' + YearS+ '.DB';
  TableType := ttParadox;
  Active := True;
  end;
  MileageTable.Filtered:=False;
  MileageTable.Filter:= '';
  MilesRadioGroup.ItemIndex:= 12;
  GotLoadedLastYear:=True;
End else MessageDlg('Last Years data not there',
                              mtError,[mbIgnore],0);
end;

procedure TMiles.MilesRadioGroupClick(Sender: TObject);
var {TtNameS,TNameS:String;TDate:TDateTime;}
 { StartDate,EndDate,Present: TDateTime;} WhichGrid:Integer;
 { Year, Month, Day, Hour, Min, Sec, MSec: Word; }
begin
  WhichGrid:=(MilesRadioGroup.ItemIndex+1);
 { Present:= Now;
  DecodeDate(Present, Year, Month, Day);  }
  If Whichgrid < 1 then
    MessageDlg('Please select a month',mtInformation,[mbIgnore],0);
  If Whichgrid < 13 then begin
 case WhichGrid of  { EncodeDate(Year, Month, Day: Word): TDateTime;
      StartDate:=EncodeDate(Year, 1, 1);
     EndDate:=EncodeDate(Year, 2, 1);
 MileageTable.Filtered:=True;
MileageTable.Filter:= '(([DATE]>= StartDate) AND ([DATE]< EndDate))';
}
 1: MileageTable.Filter:= '([MONTH]= 1)';
 2:MileageTable.Filter:= '([MONTH]= 2)';
 3:MileageTable.Filter:= '([MONTH]= 3)';
 4:MileageTable.Filter:= '([MONTH]= 4)';
 5:MileageTable.Filter:= '([MONTH]= 5)';
 6:MileageTable.Filter:= '([MONTH]= 6)';
 7:MileageTable.Filter:= '([MONTH]= 7)';
 8:MileageTable.Filter:= '([MONTH]= 8)';
 9:MileageTable.Filter:= '([MONTH]= 9)';
 10:MileageTable.Filter:= '([MONTH]= 10)';
 11:MileageTable.Filter:= '([MONTH]= 11)';
 12:MileageTable.Filter:= '([MONTH]= 12)';
  end;{case}
   MileageTable.Filtered:=True;
end else If Whichgrid = 13 then
    begin
    MileageTable.Filtered:=False;
    MileageTable.Filter:= '';
    end else If Whichgrid > 13 then
    MessageDlg('Please select a month',mtInformation,[mbIgnore],0);
MilesRadioGroup.ItemIndex:= WhichGrid-1;
End;


procedure TMiles.HelpBtnClick(Sender: TObject);
begin
Application.HelpContext(90);
end;

procedure TMiles.PrintButtonClick(Sender: TObject);
begin
Print;
end;

procedure TMiles.PrintMileageReportSpeedButtonClick(Sender: TObject);
begin
  MilesReportForm.QuickRep1.Preview;
end;


procedure TMiles.StartClick(Sender: TObject);
{Start a new record with todays date and month}
var
  Present: TDateTime;
  Year, Month, Day{, Hour, Min, Sec, MSec}: Word;
 begin
  Present:= Now;
  DecodeDate(Present, Year, Month, Day);
  MileageTable.AppendRecord([Date,Month,0,'.{Miles driven}']);
end;

procedure TMiles.RedoClick(Sender: TObject);
{Redo all checking the date and inserting the correct month}
var
  Year, Month, Day{, Hour, Min, Sec, MSec}: Word;
begin
MileageTable.First;
while not MileageTable.EOF do
begin
DecodeDate(MileageTableDATE.Value, Year, Month, Day);
MileageTable.Edit;
MileageTableMONTH.Value:= Month;
MileageTable.Post;
MileageTable.Next;
end;
end;


end.
